// GraphAlgos
// Programme implantant les algos de Floyd, Prim, Dijkstra et Bellman-Ford
// graph.h : classe CGraph definissant les graphes dont les sommets sont entiers
// "attention les sommets vont de 0  la taille du graphe"
// Date : 08/05/2003
// Auteur: Vouriot Thierry 
// http://thierry.vouriot.free.fr, http://www.yeri.fr.st
// Date : 08/05/2003

#ifndef _GRAPH_H
#define _GRAPH_H

#include <iostream>
#include <math.h>
#include <malloc.h>
#include "ens.h"

using namespace std;

#define INF 99999

// #############
// Classe CGraph
// #############
class CGraph
{
public:

	// Constructeur
	CGraph();
	// Destructeur
	~CGraph();	
	// Retourne le nombre de sommets du graphe
	int GetSize();
	// Change le nombre de sommets du graphe
	void SetSize(int som);
	// Retourne l'arc m_gr[i][j]
	int GetArc(int i, int j);	
	// Change l'arc [i][j]  la valeur val
	void SetArc(int i, int j, int val);
	// Change l'arete (les 2 arcs dans les deux sens)
	void SetArete(int i, int j, int val);
	// Retourne vrai si un arc i-j existe dans le graphe
	bool IsArc(int i, int j);
	// Teste si i est un sommet du graphe
	bool IsElem(int i);
	// Affiche la matrice reprsentant le graphe	
	void ShowGraph();
	// Permet de saisir un graphe au "clavier"
	void SetGraph();
	// Retourne la valuation minimale de tous les arcs
	int GetArcMin();
	// Retourne le nombre d'arcs
	int GetNbArcs();
	// Retourne une copie du graphe
	CGraph * Copy();
	// Ajoute le sommet size au graphe
	void AddElem();
	// Teste si l'ensemble e est egale  l'ensemble des sommets du graphe
	bool ElemsEqualEns(CEns e);
	// Retourne l'ensemble des successeurs d'un sommet 
	CEns Succ(int x);
private:
	
	// Nombre de sommets (les sommets du graphe vont de 0  size-1)
	int m_size;
	// Matrice correspondants aux arcs
	int m_gr[1000][1000];

};

#endif